<?php

namespace App\Models;

use App\Entities\SitepageEntity;

class SitepageModel extends BaseModel
{
    protected $table = "tw_sitepage";
    protected $returnType = SitepageEntity::class;
    public function __construct()
    {
        parent::__construct('Sitepage');
        $this->allowedFields = [
            ...$this->allowedFields,
            "category",
            "user_uid", 'title', "content",
            "status"
        ];
        $this->validationRules = [...$this->validationRules, ...$this->getFieldRules($this->allowedFields),];
    }
    public function getTitleField(): string
    {
        return 'title';
    }
    public function getContentField(): string
    {
        return 'content';
    }
    public function getFieldRule(string $field, array $rules, string $action = ""): array
    {
        switch ($field) {
            case "category":
                $rules[$field] =  "required|string";
                break;
            case "user_uid":
                $rules[$field] = $this->getUUIDFieldRule('required');
                break;
            case $this->getTitleField():
            case "content":
                $rules[$field] =  "required|string";
                break;
            default:
                $rules = parent::getFieldRule($field, $rules, $action);
                break;
        }
        return $rules;
    }

    public function getEntity($conditions): SitepageEntity
    {
        return $this->where($conditions)->first() ?: throw new \Exception(__FUNCTION__ . "에서 {$this->getClassName()}의 해당 데이터가 없습니다.");
    }
    public function create(array $formDatas): SitepageEntity
    {
        return $this->create_process(new SitepageEntity(), $formDatas);
    }
    public function modify(SitepageEntity $entity, array $formDatas): SitepageEntity
    {
        return $this->modify_process($entity, $formDatas);
    }

    //Index관련
    public function setIndexWordFilter(string $word): void
    {
        if ($word !== DEFAULTS['EMPTY']) {
            parent::setIndexWordFilter($word);
            $this->orLike("content", $word, "both");
        }
    }
}
